(function(global, factory) {
  typeof exports === "object" && typeof module !== "undefined" ? factory(exports, require("vue"), require("@supermatic-ui/core")) : typeof define === "function" && define.amd ? define(["exports", "vue", "@supermatic-ui/core"], factory) : (global = typeof globalThis !== "undefined" ? globalThis : global || self, factory(global["@supermatic-ui/vue-core"] = {}, global.Vue, global.core));
})(this, function(exports2, vue, core) {
  "use strict";
  const setupTemplate = (dataBinding, template, vueRef) => {
    const useRef = vueRef || vue.ref("");
    const reactivity = dataBinding.evaluateTemplateReactive(template || "");
    useRef.value = reactivity.value;
    reactivity.subscribe((value) => {
      useRef.value = value;
    });
    return useRef;
  };
  const setupEval = (dataBinding, expression, vueRef) => {
    const useRef = vueRef || vue.ref();
    const reactivity = dataBinding.evaluateReactive(expression || "");
    useRef.value = reactivity.value;
    reactivity.subscribe((value) => {
      useRef.value = value;
    });
    return useRef;
  };
  const setupBind = (dataBinding, binding, vueRef) => {
    if (binding) {
      const property = dataBinding.evaluateTemplate(binding);
      if (property != null) {
        const reactivity = dataBinding.evaluateReactive(property);
        vueRef.value = reactivity.value;
        reactivity.subscribe((value) => {
          vueRef.value = value;
        });
        return {
          value: reactivity.value,
          set: (value) => {
            reactivity.updateValue(value);
          }
        };
      }
    }
    return {
      value: vueRef.value,
      set: () => {
      }
    };
  };
  const _sfc_main$1 = /* @__PURE__ */ vue.defineComponent({
    __name: "SupermaticContainer",
    props: {
      metadata: null,
      dataBinding: null
    },
    setup(__props) {
      const props = __props;
      const wrapClassName = setupTemplate(props.dataBinding, props.metadata.container.wrapClassName);
      const className = setupTemplate(props.dataBinding, props.metadata.className);
      let components2 = props.dataBinding.registrations.getComponentRegistrations();
      return (_ctx, _cache) => {
        return vue.openBlock(), vue.createElementBlock("div", {
          class: vue.normalizeClass(vue.unref(className))
        }, [
          (vue.openBlock(true), vue.createElementBlock(vue.Fragment, null, vue.renderList(props.metadata.container.components, (item, index) => {
            return vue.openBlock(), vue.createElementBlock(vue.Fragment, { key: index }, [
              props.metadata.container.wrap ? (vue.openBlock(), vue.createElementBlock("div", {
                key: 0,
                class: vue.normalizeClass(vue.unref(wrapClassName))
              }, [
                (vue.openBlock(), vue.createBlock(vue.resolveDynamicComponent(vue.unref(components2)[item.type]), {
                  metadata: item,
                  dataBinding: __props.dataBinding
                }, null, 8, ["metadata", "dataBinding"]))
              ], 2)) : (vue.openBlock(), vue.createBlock(vue.resolveDynamicComponent(vue.unref(components2)[item.type]), {
                key: 1,
                metadata: item,
                dataBinding: __props.dataBinding
              }, null, 8, ["metadata", "dataBinding"]))
            ], 64);
          }), 128))
        ], 2);
      };
    }
  });
  const _sfc_main = /* @__PURE__ */ vue.defineComponent({
    __name: "SupermaticUi",
    props: {
      configuration: null,
      onInit: { type: Function },
      registrations: null
    },
    setup(__props) {
      const props = __props;
      const wrapClassName = vue.ref("");
      if (props.configuration && props.configuration.type === "layout") {
        console.log("[SupermaticUi] configuration", props.configuration);
      } else {
        console.log("[SupermaticUi] no configuration");
      }
      let schemaDefinition;
      let dataBinding;
      let registrations = props.registrations;
      let components2 = {};
      if (props.configuration != null && props.configuration.dataBinding != null && typeof props.configuration.dataBinding["type"] === "string") {
        schemaDefinition = props.configuration.dataBinding;
        dataBinding = core.dataBindingBuilder(
          {},
          schemaDefinition,
          registrations || core.createRegistrations({
            container: _sfc_main$1
          })
        );
        components2 = dataBinding.registrations.getComponentRegistrations();
        setupTemplate(dataBinding, props.configuration.layout.wrapClassName, wrapClassName);
        if (props.onInit) {
          props.onInit(dataBinding);
        }
      }
      console.log("[SupermaticUi] components", components2);
      return (_ctx, _cache) => {
        var _a;
        return vue.openBlock(true), vue.createElementBlock(vue.Fragment, null, vue.renderList((_a = props.configuration) == null ? void 0 : _a.layout.components, (item, index) => {
          var _a2;
          return vue.openBlock(), vue.createElementBlock(vue.Fragment, { key: index }, [
            ((_a2 = props.configuration) == null ? void 0 : _a2.layout.wrap) ? (vue.openBlock(), vue.createElementBlock("div", {
              key: 0,
              class: vue.normalizeClass(wrapClassName.value)
            }, [
              (vue.openBlock(), vue.createBlock(vue.resolveDynamicComponent(vue.unref(components2)[item.type]), {
                metadata: item,
                dataBinding: vue.unref(dataBinding)
              }, null, 8, ["metadata", "dataBinding"]))
            ], 2)) : (vue.openBlock(), vue.createBlock(vue.resolveDynamicComponent(vue.unref(components2)[item.type]), {
              key: 1,
              metadata: item,
              dataBinding: vue.unref(dataBinding)
            }, null, 8, ["metadata", "dataBinding"]))
          ], 64);
        }), 128);
      };
    }
  });
  const components = {
    SupermaticUi: _sfc_main,
    SupermaticContainer: _sfc_main$1
  };
  const UseSupermaticUi = {
    install: (app) => {
      for (let componentKey in components) {
        console.log("install component", componentKey);
        app.component(componentKey, components[componentKey]);
      }
    }
  };
  exports2.SupermaticContainer = _sfc_main$1;
  exports2.SupermaticUi = _sfc_main;
  exports2.UseSupermaticUi = UseSupermaticUi;
  exports2.setupBind = setupBind;
  exports2.setupEval = setupEval;
  exports2.setupTemplate = setupTemplate;
  Object.defineProperty(exports2, Symbol.toStringTag, { value: "Module" });
});
